


#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>


#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"

#include "../as/asfrontend.h"



int Asfrontend_new(frontend,app,Interpreter,servername,portnumber,username,flag)
struct AsfrontenD **frontend;
char *app;                             /* should be (void *) */
int (*Interpreter) ();
char *servername;
int portnumber;
char *username;
int flag;
{
 struct AsfrontenD *f;
 char keydir[SfileadrL];
 int ret;

 *frontend= f= TSOB_FELD(struct AsfrontenD,1);
 if(f==NULL)
   return(-1);
 f->access= NULL;
 f->access_is_own= 0;
 f->sconn= NULL;
 f->mark_counter= 0;
 f->mark_received= 0;
 f->init_id= NULL;
 f->end_received= 0;
 f->vmsg= NULL;
 f->buf[0]= 0;
 f->bufcount= 0;
 if(app==NULL)
   f->app= (char *) f;
 else
   f->app= app;
 f->Interpreter= Interpreter;

 /* set user id . if not given, no encryption will take place */
 ret= Saccess_new(&(f->access),0);
 if(ret<=0)
   goto failed;
 f->access_is_own= 1;
 ret= Sfile_home_adr("tnl_keydir",keydir,0);
 if(ret<=0)
   goto failed;
 ret= Saccess_append(f->access,"connection","all","keydirectory",keydir,0);
 if(ret<=0)
   goto failed;
 if(username[0]!=0) {
   ret= Asfrontend_set_user(f,username,0);
   if(ret<=0)
     goto failed;
 }

 /* open connection to server */;
 ret= Asfrontend_open(f,servername,portnumber,0);
 if(ret<=0) {
no_connection:;
   fprintf(stderr,"no connection to %s %ld\n",servername,portnumber);
   goto failed;
 }
 
 return(1);
failed:
 Asfrontend_destroy(frontend,0);
 return(-1);
}


int Asfrontend_destroy(frontend,flag)
struct AsfrontenD **frontend;
int flag;
{
 if((*frontend)==NULL)
   return(0);
 Sregex_string(&((*frontend)->init_id),NULL,0);
 Asviewmsg_destroy(&((*frontend)->vmsg),0);
 Sconn_destroy(&((*frontend)->sconn),0);
 if((*frontend)->access_is_own)
   Saccess_destroy(&((*frontend)->access),0);
 Smem_freE((char *) (*frontend));
 *frontend= NULL;
}


int Asfrontend_set_user(frontend,username,flag)
struct AsfrontenD *frontend;
char *username;
int flag;
{
 int ret;

 ret= Saccess_append(frontend->access,"connection","all","user",username,0);
 return(ret);
}


int Asfrontend_open(frontend,servername,portnumber,flag)
struct AsfrontenD *frontend;
char *servername;
int flag;
{
 int ret;
 struct SconN *sconn;

 ret= Sconn_tcpclient_new(&(frontend->sconn),servername,portnumber,
                          frontend->access,0);
 if(ret<=0)
   goto ex;
 sconn= frontend->sconn;

 /* if a username is set, this function negociates encryption */
 ret= Sconn_try_tunnel(sconn,0);
 if(ret<=0)
   goto ex;
 ret= 1;
ex:;
 Asfrontend_show_conn_messages(frontend,0);
 return(ret);
}


int Asfrontend_show_conn_messages(frontend,flag)
/* SconN puts its messages into SaccesS from where this function fetches them */
struct AsfrontenD *frontend;
int flag;
{
 int ret;
 char *message= NULL,*origin= NULL;

 do {
   ret= Saccess_consume_last(frontend->access,"message","stdout","any",
                             &origin,&message,0);
   if(ret<0)
     goto ex;
   if(ret==0)
 break;
   fprintf(stdout,"%s\n",message);
 } while(1);
 do {
   ret= Saccess_consume_last(frontend->access,"message","stderr","any",
                             &origin,&message,0);
   if(ret<0)
     goto ex;
   if(ret==0)
 break;
   fprintf(stderr,"%s\n",message);
 } while(1);
 ret= 1;
ex:;
 Sregex_string(&message,NULL,0);
 Sregex_string(&origin,NULL,0);
 return(ret);
}


int Asfrontend_send(frontend,cmd,flag)
struct AsfrontenD *frontend;
char *cmd;
int flag;
/*
 bit0= do not prepend -mark
*/
{
 int ret,l;
 char *msg= NULL,line[80];

 if(Asfrontend_has_ended(frontend,0))
   return(0);

 if(!(flag&1)) {
   frontend->mark_counter++;
   frontend->mark_received= 0;
   sprintf(line,"-mark:_sfrontend_%ld:",frontend->mark_counter);
 } else
   line[0]= 0;
 Sregex_string(&msg,line,0);
 l= strlen(cmd);
 if(Sregex_string(&msg,cmd,1)<=0)
   {ret= -1; goto ex;}
 if(l==0) {
   if(Sregex_string(&msg,"\n",1)<=0)
     {ret= -1; goto ex;}
 } else {
   if(cmd[l-1]!='\n')
     if(Sregex_string(&msg,"\n",1)<=0)
       {ret= -1; goto ex;}
 }
 ret= Sconn_write(frontend->sconn,msg,strlen(msg),4);
ex:;
 Sregex_string(&msg,NULL,0);
 if(ret<=0)
   Asfrontend_show_conn_messages(frontend,0);
 return(ret);
}


int Asfrontend_check_reply(frontend,flag)
struct AsfrontenD *frontend;
int flag;
/*
 bit0= eventually print message to stdout
*/
{
 int ret,bytecount;
 char *msgtype,*bytept;           /* only references, not copies */
 char expected_mark_id[80];
 struct AsviewmsG *msg;

 msg= frontend->vmsg;
 if(Asviewmsg_is_complete(msg,0)<=0) 
   return(0); /* we were called prematurely */

 Asviewmsg_fetch_type(msg,&msgtype,0);

 /* This is an example how to access message fields by name */
 /* For message types and field names see : 
     sagent -help : Appendix agent B : Format of Notification Messages
  */
 /* Look for the most recent mark notification requested by Asfrontend_send()
    and having state "end".
  */
 if(strcmp(msgtype,"mark")==0) {
   sprintf(expected_mark_id,"_sfrontend_%ld",frontend->mark_counter);
   ret= Asviewmsg_fetch_field(msg,"id",&bytept,&bytecount,0);
   if(ret<=0) {
ill_mark:;
     fprintf(stderr,"--- ill mark notification received.\n");
     return(0);
   }
   if(strcmp(expected_mark_id,bytept)!=0) 
     return(0);
   ret= Asviewmsg_fetch_field(msg,"state",&bytept,&bytecount,0);
   if(ret<=0)
     goto ill_mark;
   if(strcmp(bytept,"end")!=0) 
     return(0);
   if(flag&1)
     printf("+++ expected end mark received, all pending commands done\n");
   frontend->mark_received= 1;
 } else if(strcmp(msgtype,"init")==0) {
   ret= Asviewmsg_fetch_field(msg,"id",&bytept,&bytecount,0);
   if(ret<=0) {
ill_init:;
     fprintf(stderr,"--- ill init notification received.\n");
     return(0);
   }
   if(Sregex_string(&(frontend->init_id),bytept,0)<=0)
     return(-1);
 } else if(strcmp(msgtype,"end")==0) {
   frontend->end_received= 1;
 } else 
   return(0);
 return(1);
}


int Asfrontend_fetch_vmsg(frontend,flag)
struct AsfrontenD *frontend;
int flag;
/*
 bit0= non-blocking mode
 bit2= do not read data from fd (only consume remnant buffer)
*/
/* return:
   1 = success, 
   2 = message still incomplete
 <=0 = failure
*/
{
 int ret,count=0,bufcount,pass;
 char *buf,*rpt,*cpt;
 struct SconN *sconn;

from_scratch:;
 if(Asfrontend_has_ended(frontend,0))
   return(0);

 buf= frontend->buf;
 bufcount= frontend->bufcount;
 rpt= buf;
 sconn= frontend->sconn;

 if(Asviewmsg_is_complete(frontend->vmsg,0)>0) {
   /* starting a new message */
   Asviewmsg_destroy(&(frontend->vmsg),0);
 }
 
 /* first consume buffered bytes. in a second pass eventually read new ones */
 /* at most one buffer full of bytes will be read */
 for(pass= !frontend->bufcount;pass<2;pass++) {
   if(pass==0) {
     count= frontend->bufcount;
   } else {
     frontend->bufcount= 0;
     ret= Sconn_read(sconn,buf,sizeof(frontend->buf)-1,&count,flag&4);
     if(ret<=0)
       {ret= 0; goto ex;}
     if(ret!=1 || count<0)
       {ret= 2; goto ex;}
     buf[count]= 0;                  /* for better readability with debugger */
   }

   ret= 1;
   rpt= buf;
   while(rpt-buf<count) {
     ret= Asviewmsg_parse_head(&(frontend->vmsg),rpt,count-(rpt-buf),&rpt,0);
     if(ret!=1)
   break;
     ret= Asviewmsg_parse_fields(frontend->vmsg,rpt,count-(rpt-buf),&rpt,0);
     if(ret==3)
       ret= 2;
     if(ret!=1)
   break;

     /* message is complete, preserve rest of buffered bytes. */
     cpt= buf;
     frontend->bufcount= count-(rpt-buf);
     for(;rpt-buf<count;rpt++)
       *(cpt++)= *rpt;

     /* Eventually react on mark_counter notification */
     Asfrontend_check_reply(frontend,0);
     ret= 1;
     goto ex;
   }
   if(ret<=0)
     goto ex;
 }

 ret= 2; 
ex:;
 if(ret==2 && !(flag&1)) {
   if(Asfrontend_has_data(frontend,0))
     goto from_scratch;
   Sfile_fd_is_ready(Asfrontend_get_fd(frontend,0),
                     1000000,1); /* sleep a second if nothing happens at fd */
   goto from_scratch;
 }
 if(ret<=0)
   Asfrontend_show_conn_messages(frontend,0);
 return(ret);
}


int Asfrontend_get_fd(frontend,flag)
struct AsfrontenD *frontend;
int flag;
{
  return(Sconn_get_fd(frontend->sconn,0));
}


int Asfrontend_has_data(frontend,flag)
struct AsfrontenD *frontend;
int flag;
{
 if(Asfrontend_has_ended(frontend,0))
   return(0);
 if(frontend->bufcount>0)
   return(1);
 if(flag&1)
   return(0);
 if(Sconn_is_ready(frontend->sconn,0))
   return(1);
 return(0);
}


int Asfrontend_synchronize(frontend,flag)
/*
 Receive and interpret replies until current end mark is received
*/
struct AsfrontenD *frontend;
int flag;
{
 int ret= 1;

 while(!frontend->mark_received) {


#ifdef NIX
   /* 
      Usage of Asfrontend_fetch_vmsg() in blocking mode.
      There is no return(2) in this mode.
   */
   ret= Asfrontend_fetch_vmsg(frontend,0);
   if(ret<=0) {
     fprintf(stderr,"--- reading of reply failed.\n");
     return(-4);
   }

   /* handle received message */;
   if(frontend->Interpreter!=NULL) {
     ret= frontend->Interpreter(frontend->app,frontend,0);
     if(ret<0 || ret==3)
 break;
   }
#else /* NIX */

   if(!Asfrontend_has_data(frontend,0))
     /* sleep a second if nothing happens at fd */
     Sfile_fd_is_ready(Asfrontend_get_fd(frontend,0),1000000,1);
   ret= Asfrontend_callback(frontend);
   if(ret<0 || ret==3)
 break;
   if(Asfrontend_has_ended(frontend,0)) {
     ret= 3;
 break;
   }

#endif /* ! NIX */

 }
 return(ret);
}


int Asfrontend_send_initial(frontend,flag)
struct AsfrontenD *frontend;
int flag;
/*
 bit0= listen for reply in blocking mode
*/
{
 int ret;
 /* subscribe to all message types */
 static char initcmd[]= {"-add_view:-:all:default:encapsulated"};

 ret= Asfrontend_send(frontend,initcmd,!(flag&1));
 if((!(flag&1))||ret<=0)
   return(ret);
 ret= Asfrontend_synchronize(frontend,0);
 if(ret<=0) 
   return(ret);
 return(1);
}


int Asfrontend_get_vmsg(frontend,msg,flag)
struct AsfrontenD *frontend;
struct AsviewmsG **msg;        /* only reference, not a copy */
int flag;
{
 if(!Asfrontend_vmsg_is_valid(frontend,0))
   return(0);
 *msg= frontend->vmsg;
 return(1);
}


int Asfrontend_print_interpreter(frontend,frontend_again,flag)
struct AsfrontenD *frontend;             /* this is provided by frontend->app */
struct AsfrontenD *frontend_again;       /* this is frontend itself */
int flag;
/*
 possible return values:
  -1=failure, abort receiving
   0=failure, continue receiving
   1=all went well
   2=all went well, more data expected (currently no difference to 1)
   3=all went well, end receiving
*/
{
 int ret,fieldcount,bytecount,i;
 char *msgtype,*fieldname,*bytept;           /* only references, not copies */
 char nametext[80];
 struct AsviewmsG *msg;                     /* only reference, not a copy */

 if(Asfrontend_has_ended(frontend,0))
   return(3);

 if(Asfrontend_get_vmsg(frontend,&msg,0)<=0)
   return(0);
 if(Asviewmsg_is_complete(msg,0)<=0) 
   return(0); /* we were called prematurely */

 /* This procedure explores the message without expecting particular fields
    See Asfrontend_check_reply() for an example of accessing fields by name */

 Asviewmsg_fetch_type(msg,&msgtype,0);
 fieldcount= Asviewmsg_get_fieldcount(msg,0);
 printf("%s%s\n","========================================",
                 "=======================================");
 printf("  %s  %ld\n",msgtype,fieldcount);
 printf("%s%s\n","----------------------------------------",
                 "---------------------------------------");
 for(i=0;i<fieldcount;i++) {
   Asviewmsg_fetch_field_idx(msg,i,&fieldname,&bytept,&bytecount,0);
   /* With the settings of Asfrontend_send_initial() we only receive
      printable data representations. But beware if you requested
      representation "data" for files. */
   sprintf(nametext,"%s[%ld]",fieldname,bytecount);
   printf("  %2ld :  %-12s= '%s'\n",i,nametext,bytept);
 }
 return(1); 
}


int Asfrontend_vmsg_is_valid(frontend,flag)
struct AsfrontenD *frontend;
int flag;
{
 int ret;

 if(frontend->vmsg==NULL)
   return(0);
 ret= Asviewmsg_is_complete(frontend->vmsg,0);
 return(ret);
}


int Asfrontend_has_ended(frontend,flag)
struct AsfrontenD *frontend;
int flag;
{
 return(!!frontend->end_received);
}


int Asfrontend_callback(frontend)
/*
   Usage of Asfrontend_fetch_vmsg() in non-blocking mode.

   Non-blocking mode returns 1 in case of success, 
                             2 in case of still incomplete vmsg
                           <=0 in case of failure
   The partial reads of a message may be mixed with arbitrary other
   activities as long as the frontend's SconN and its file descriptor
   remain unaltered.

   Sketch of a callback function triggered by some kind of select() 
   dreturns the same values as Asfrontend_fetch_vmsg() 
*/
struct AsfrontenD *frontend;
/*
 return: see also Asfrontend_fetch_vmsg() and ../as/asfrontend.h:(*Interpreter)()
  -1 = failure, abort receiving
   0 = failure, continue receiving
   1 = all went well
   2 = incomplete message pending (still more data expected)
   3 = all went well, but end receiving
*/
{
 int ret,dont_read= 0;

 while(1) {
   ret= Asfrontend_fetch_vmsg(frontend,1|dont_read);
   if(ret!=1)
 break;

   /* handle received message */;
   if(frontend->Interpreter!=NULL) {
     ret= frontend->Interpreter(frontend->app,frontend,0);
     if(ret<0)
 break;
     if(ret==3)
 break;
   }

   /* care for possibly pending data in buffers */
   if(!Asfrontend_has_data(frontend,0))
 break;
   /* read from buffers but not from filedescriptor again */
   dont_read= 4;
 }
 return(ret);
}


int Asfrontend_input_loop(frontend,flag)
/* 
   Sketch of a synchronous input-send-receive cycle .
*/
struct AsfrontenD *frontend;
int flag;
{
 char line[1024];
 int ret;

 while(1) {

   /* ( get input line from stdin ) */
 printf("%s%s\n","########################################",
                 "#######################################");
   printf("enter command line :\n");
   if(Sfile_fgets(line,sizeof(line)-1,stdin)==NULL)
 break;

   /* send to server */
   ret= Asfrontend_send(frontend,line,0);
   if(ret<=0) {
     fprintf(stderr,"--- sending of command failed.\n");
     return(-3);
   }

   /* read reply */
   ret= Asfrontend_synchronize(frontend,0);
   if(ret<=0) {
     fprintf(stderr,"--- reading of reply failed.\n");
     return(-4);
   }
   if(ret==3) {
     printf("*** input loop ends by wish of server or Interpreter()\n");
     return(1);
   }

 }
 return(1);
}


int Asfrontend__helptext(reply,flag)
char **reply;            /*  *reply MUST point to malloced memory or be NULL */
int flag;
{
 static Asfrontend_helplinE helptext[]= {
"",
"struct AsfrontenD and its functions provide in the role of a frontend client",
"easy access to an AsagenT server via TCP/IP. See  sagent -help  for more",
"information about AsagenT communications.",
"",
"For convenient use of AsfrontenD an application should provide an interpreter",
"function and an application object which get involved when a reply message",
"has completely arrived. (see below for details)",
"",
"AsfrontenD is made out of these modules (see also makefile of stic) :",
"  asfrontend asvmsg sregex sfile stcp stunnel sblowfish sconn saccess smem",
"",
"All operations are accessible by int functions. There should be no need",
"to include any specific headers in the application code.",
"",
"Elementary steps to establish and later shut down a frontend connection :",
"",
"  Asfrontend_new() ",
"       creates a frontend object and connects to the server.",
"       It needs an application object pointer (NULL=itself),",
"       a pointer to an interpreter function for incoming replies,",
"       the hostname of the server,",
"       the portnumber of the server,",
"       the username (\"\"=unencrypted anonymous)",
"",
"  Asfrontend_send_initial()",
"       establishes a backchannel at the server side via -add_view. Without",
"       such a backchannel the server will execute commands but not reply",
"       anything. (see sagent -help for information about -add_view)",
"",
"  Asfrontend_destroy()",
"       closes the connection and removes the frontend object from memory.",
"",
"",
"Usage of an established connection:",
"",
"  Asfrontend_get_fd()",
"       obtain the file descriptor of the connection. It may be needed by the",
"       application, e.g. for use with select() .",
"",
"  Asfrontend_send()",
"       sends a command line to the server.",
"",
"  Asfrontend_callback()",
"       should be called whenever availability of data has been detected at",
"       the connection's file descriptor. This function calls the interpreter",
"       function with every single incoming reply message as soon as it is",
"       completly received. It does not block if no data are available at",
"       the file descriptor.",
"       This function is modest in grabbing processor time because it will",
"       only read a limited number of bytes before returning. Any unprocessed",
"       input data will be pending at the file descriptor and not at internal",
"       buffers of AsfrontenD or its helpers. Thus select() will detect them",
"       and Asfrontend_callback() may be invoked again.",
"",
"  Asfrontend_synchronize()",
"       receives all replies and only returns after the end mark of the",
"       most recent command has been received. This function calls the",
"       interpreter function with every single incoming reply message as",
"       soon it is completly received.",
"",
"",
"Constraints of application object and interpreter function:",
"",
"  The above functions call the interpreter function in the following way:",
"",
"    char *application_object_pointer;",
"    struct AsfrontenD *frontend;",
"    int flag = 0;",
"    int ret;",
"    ret= Interpreter(application_object_pointer,frontend,flag);",
"",
"  The application_object_pointer therefore should lead to all data necessary",
"  to react properly to possible replies in the context of the application.",
"",
"  The return value may be:",
"     -1=failure, abort receiving",
"      0=failure, continue receiving",
"      1=all went well",
"      2=all went well, more data expected (currently no difference to 1)",
"      3=all went well, end receiving",
"",
"  An example of an interpreter function is:",
"",
"  Asfrontend_print_interpreter()",
"       it gets the frontend pointer two times since frontend serves as",
"       application object too.",
"       In main() of this program Asfrontend_print_interpreter() is used",
"       as argument of Asfrontend_new() together with a NULL pointer for",
"       the application object.",
"",
"  Another example of handling a received message can be seen in ",
"  Asfrontend_check_reply() .",
"",
"AsfrontenD provides a struct AsviewmsG which contains the parsed components",
"of a message: type, fieldcount, fields . About the structure of notification",
"messages see  sagent -help , Appendix B : Format of Notification Messages.",
"An interpreter function may access the AsviewmsG via the following methods :",
"",
"  Asfrontend_get_vmsg()",
"       obtains a pointer to the current message object.",
"",
"  Asviewmsg_is_complete()",
"       confirms that the message has been received completely.",
"",
"  Asviewmsg_fetch_type()",
"       obtains a pointer to a string containing the message type",
"",
"  Asviewmsg_fetch_field()",
"       obtains via fieldname the bytecount and a pointer to the databytes.",
"",
"  Asviewmsg_get_fieldcount()",
"       returns the number of fields in the message",
"",
"  Asviewmsg_fetch_field_idx()",
"       obtains via fieldnumber pointers to fieldname, bytes and their count.",
"",
"",
"Examples and documentation:",
"",
"  main()",
"       implements a primitive client which requests input lines and shows",
"       the reply messages. Demonstrates the complete lifecycle of a ",
"       AsfrontenD object.",
"       Define macro Asfrontend_without_maiN to suppress the main() function.",
"",
"  Asfrontend_input_loop()",
"       the primitive synchronous request-reply loop used by main().",
"       This function calls Asfrontend_synchronize() and thus the interpreter.",
"",
"  Asfrontend_helptext()",
"       replies this text in a malloced string.",
"",
"  and all the other functions in this sourcecode.",
"",
"",
"More primitive methods which do not require an application object or",
"an interpreter function:",
"",
"  Asfrontend_fetch_vmsg()",
"       fetches a message respectively the available part of a message into",
"       the message buffer of the frontend object. This function is modest",
"       in grabbing processor time because it will only read a limited number",
"       of bytes before returning. Therefore repeated calls may be necessary.",
"       select() can not detect possibly buffered data.",
"       Therefore use Asfrontend_has_data() to determine wether you are done.",
"",
"  Asfrontend_vmsg_is_valid()",
"       returns 1 if the frontend object has got a valid current reply",
"       message. returns 0 else.",
"",
"  Asfrontend_has_data()",
"       returns 1 if there are data pending in the buffers or at the file",
"       descriptor. returns 0 else.",
"",
"",
"Supporting functions which hardly will be called by applications:",
"",
"  Asfrontend_check_reply()",
"       employed by Asfrontend_fetch_vmsg() to keep track of messages",
"       interesting to the AsfrontenD object. E.g. command mark for",
"       synchronization or end mark for end of connection.",
"",
"  Asfrontend_show_conn_messages()",
"       reads the messages of lower i/o layers and puts them to stdout/stderr.",
"",
"  Asfrontend_open()",
"       is called by Asfrontend_new() to establish the TCP/IP connection.",
"",
"  Asfrontend_set_user()",
"       is called by Asfrontend_new() to set the user id for the connection.",
"",
"This software is copyright 2001, Thomas Schmitt stic-source@gmx.net and",
"provided to you without any warranty under an open source BSD license.",
"(see file COPYING)",
"",
"@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
};
 int ret,i;
 char line[SfileadrL];

 if(Sregex_string(reply,"",0)<=0)
   {ret= -1; goto ex;};
 for(i=0;strcmp(helptext[i],
                "@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
                )!=0;i++) {
   sprintf(line,"%s\n",helptext[i]);
   if(Sregex_string(reply,line,1)<=0)
     {ret= -1; goto ex;};
 }
 ret= 1; goto ex;
ex:;
 return(ret);
}



#ifndef Asfrontend_without_maiN

main(argc,argv)
int argc;
char **argv;
{
 struct AsfrontenD *frontend= NULL;
 int portnumber= 0,ret, helpmode= 0;
 char username[1024],*servername;
 char *helptext= NULL;

 static int blocking_mode= 1;


 /* full memory supervision */
 Smem_set_record_items(1); 

 
 /* ( check arguments ) */
 if(argc < 3) {
   if(argc == 2)
     if(strcmp(argv[1],"-help")==0)
       helpmode= 1; 
   if(!helpmode)
     fprintf(stderr,"usage: %s hostname portnumber [username]\n",argv[0]);
   ret= Asfrontend__helptext(&helptext,0);
   if(ret>0)
     fprintf(stdout,"%s",helptext);
   exit(1);
 } else if (argc==3) {
   username[0]= 0;
 } else {
   if(strlen(argv[3])<sizeof(username)-1) {
     strcpy(username,argv[3]);
   } else {
     fprintf(stderr,"%s : username too long : '%'\n",argv[3]);
     exit(1);
   }
 }
 servername= argv[1];
 sscanf(argv[2],"%ld",&portnumber);
 if(portnumber<=0) {
   fprintf(stderr,"%s : no usable portnumber '%'\n",argv[2]);
     exit(1);
 }


 /* get a frontend object */
 /* It is its own master application and uses Asfrontend_print_interpreter()
    as interpreter for incoming replies */
 ret= Asfrontend_new(&frontend,NULL,Asfrontend_print_interpreter,
                    servername,portnumber,username,0);
 if(ret<=0) {
creation_failed:;
   fprintf(stderr,"%s : creation of frontend object failed\n",argv[0]);
   exit(2);
 }

 /* Not needed here, but necessary in more flexible I/O environments:
    How to obtain the filedescriptor for possible usage with select() */
 fprintf(stderr,"connected to %s %ld via filedescriptor   %ld\n",
                servername,portnumber,
                Asfrontend_get_fd(frontend,0));


 /* Send initial commands to establish a backchannel at the server.
    This function subscribes to all types of notification messages */
 ret= Asfrontend_send_initial(frontend,1);
 if(ret<=0) {
   fprintf(stderr,"%s : sending of initial commands failed.\n",argv[0]);
   exit(3);
 }

 /* This example uses the synchronous input loop */
 /* for asynchronous i/o see Asfrontend_callback() */
 ret= Asfrontend_input_loop(frontend,0);
 if(ret<0) 
   exit(-ret);

 /* close connection to server */
 Asfrontend_destroy(&frontend,0);


 /* final memory clearance check */
 Smem_stderr(1|2);


 exit(0);
}

#endif /* ! Asfrontend_without_maiN */



