
/*
 cc -g -c sagent.c
*/

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>


#include "../as/asagent.h"

struct AsagenT *agent= NULL;


#include <signal.h>

void Cleanup_handler_pipe()
{
 return;
}


void Cleanup_handler_exit()
{
 alarm(0);
 Asagent_stderr(agent,"\n\nTIMEOUT ! Program aborted\n\n",1);
 Asagent_destroy(&agent,0);
 exit(4);
}


main(argc,argv)
int argc;
char **argv;
{
 int ret,ard= 1;

 /* <<< preliminary signal handling */
 signal(SIGPIPE,Cleanup_handler_pipe);
 signal(SIGALRM,Cleanup_handler_exit);


 ret= Asagent_new(&agent,argv[0],1,0);
 if(ret<=0) {
   fprintf(stderr,"%s : creation of agent object failed\n",argv[0]);
   exit(1);
 }

 ard= 1;
 ret= Asagent_read_options(agent,argc,argv,&ard,0);
 if(ret<=0) {
   ret= 2;
   goto ex;
 }
 if(ret==3)
   goto ok;

 ret= Asagent_loop(agent,1);
 if(ret<=0) {
   fprintf(stderr,"%s : event loop aborted\n",argv[0]);
   ret= 3;
   goto ex;
 }
 if(ret==3)
   goto ok;

ok:;
 ret= 0;
ex:
 Asagent_destroy(&agent,0);
 exit(ret);
}


