
#ifndef Imgstd_includeD
#define Imgstd_includeD

#include "imgsamp.h"


struct ImgstD {

 struct ImgrgB *rgb;

 double red[Imgsamp_max_sizE];
 double green[Imgsamp_max_sizE];
 double blue[Imgsamp_max_sizE];

 int spoints;
 int elength;
 int width;
 int height;
 int depth;
 double wstep;
 double hstep;

 int lines_seen;
 int pixel_seen;

};


#endif /* ! Imgstd_includeD */


/*
 ImgstD reads RGB data of an image file and computes the RGB data of a
 standardized image sample. The image file has to be represented as an
 opened ImgrgB object.

functions:
 Imgstd...
  _new()            create new object
  _read_rgb()       read image file and compute std RGB values
  _destroy()        destroy object

  _rgb_sizes()      transfer size information from rgb to std
  __idx()           map rgb geometric coordinate to sample geometric coordinate
  _add_pixels()     add the pixels of a possibly split line to std RGB data
  _add_line()       add an image line to std RGB data
*/

